\ 94 CORE EXT

: .R ( n1 n2 -- ) \ 94 CORE EXT
\    n1      n2 .
\   ,    n1,   n2,
\          
\ .
  >R DUP >R ABS
  S>D <# #S R> SIGN #>
  R> OVER - 0 MAX SPACES TYPE
;
: 0> ( n -- flag ) \ 94 CORE EXT
\ flag ""    ,  n  
  0 >
;

: MARKER ( "<spaces>name" -- ) \ 94 CORE EXT
\   .  name,  .
\     ,  .
\ name : ( -- )
\        
\  ,      name.  
\  name    .   
\     ,  
\         
\  .    , 
\    ,  .
  HERE
\  [C]HERE , [E]HERE ,
  GET-CURRENT ,
  GET-ORDER DUP , 0 ?DO DUP , @ , LOOP
  CREATE ,
  DOES> @ DUP \ ONLY
\  DUP @ [C]DP ! CELL+
\  DUP @ [E]DP ! CELL+
  DUP @ SET-CURRENT CELL+
  DUP @ >R R@ CELLS 2* + 1 CELLS - R@ 0
  ?DO DUP DUP @ SWAP CELL+ @ OVER ! SWAP 2 CELLS - LOOP
  DROP R> SET-ORDER
  DP !
;
CODE PICK ( xu ... x1 x0 u -- xu ... x1 x0 xu ) \ 94 CORE EXT
\  u.  xu   .  
\ ,    PICK   ,
\  u+2 .
     MOV  ECX, [EBP]
     PUSH EBP
     ADD  EBP, ECX
     ADD  EBP, ECX
     ADD  EBP, ECX
     ADD  EBP, ECX
     MOV  EAX, 4 [EBP]
     POP  EBP
     MOV  [EBP], EAX
     RET
END-CODE

CODE ROLL ( xu xu-1 ... x0 u -- xu-1 ... x0 xu ) \ 94 CORE EXT
\  u.  u+1    .
\   ,    ROLL
\     u+2 .
     MOV ECX, [EBP]
     ADD EBP, # 4
     JECXZ @@1
     PUSH EBP
     ADD EBP, ECX
     ADD EBP, ECX
     ADD EBP, ECX
     ADD EBP, ECX
     MOV EBX, [EBP]
@@2: SUB EBP, # 4
     MOV EAX, [EBP]
     MOV 4 [EBP], EAX
     LOOP @@2
     POP EBP
     MOV [EBP], EBX
@@1: RET
END-CODE

: SAVE-INPUT ( -- xn ... x1 n )  \ 94 CORE EXT
\ x1 - xn       
\    RESTORE-INPUT.
  SOURCE-ID 0>
  IF TIB #TIB @ 2DUP C/L 2 + ALLOCATE THROW DUP >R SWAP CMOVE
     R> TO TIB  >IN @
     SOURCE-ID FILE-POSITION THROW
     5
  ELSE BLK @ >IN @ 2 THEN
;
: RESTORE-INPUT ( xn ... x1 n -- flag ) \ 94 CORE EXT
\       , 
\  x1 - xn. flag "",    
\     .
\   ,   , 
\     ,     .
  SOURCE-ID 0>
  IF DUP 5 <> IF 0 ?DO DROP LOOP -1 EXIT THEN
     DROP SOURCE-ID REPOSITION-FILE ?DUP IF >R 2DROP DROP R> EXIT THEN
     >IN ! #TIB ! TO TIB FALSE
  ELSE DUP 2 <> IF 0 ?DO DROP LOOP -1 EXIT THEN
     DROP >IN ! BLK ! FALSE
  THEN
;
: TUCK ( x1 x2 -- x2 x1 x2 ) \ 94 CORE EXT
\     ()    .
  SWAP OVER
;
: U.R ( u n -- ) \ 94 CORE EXT
\    u      n .
\   ,    u,   n,
\          
\ .
  >R  U>D <# #S #>
  R> OVER - 0 MAX SPACES TYPE
;
: U> ( u1 u2 -- flag ) \ 94 CORE EXT
\ flag ""    ,  u1   u2.
  SWAP U<
;
: UNUSED ( -- u ) \ 94 CORE EXT
\ u -  ,   ,  HERE,
\  .
  IMAGE-SIZE  PAD IMAGE-BEGIN -  -
;
: WITHIN ( n1|u1 n2|u2 n3|u3 -- flag ) \ 93 CORE EXT
\     n1|u1    
\ n2|u2    n3|u3,  "", 
\ (n2|u2<n3|u3  (n2|u2<=n1|u1  n1|u1<n3|u3))
\  (n2|u2>n3|u3  (n2|u2<=n1|u1  n1|u1<n3|u3)) "",
\   "".
\   ,  n1|u1, n2|u2  n3|u3
\      .
  OVER - >R - R> U<
;
